<?php if (!defined('PmWiki')) exit();

# slightly modified version of feralsimplecalendar for use with Mark Things Done!
$RecipeInfo['MTDSimpleCalendar']['Version'] = '2010-03-26';

# load the stylesheet (idea from Wikilog)
//$HTMLHeaderFmt[] = "<link rel='stylesheet' href='\$FarmPubDirUrl/css/mtdsimplecalendar.css' type='text/css' />";

//My custom CSS;
SDV($HTMLStylesFmt['mtdsimplecalendar'], "
div#mtdsimplecalendar {
	font-size: smaller;
}

table.mtdsimplecalendar {
	border: 1px solid #000000;
	border-collapse: collapse;
}
table.mtdsimplecalendar caption {
	text-align: center;
	font-weight: bold;
	padding-top: 3px;
	padding-bottom: 3px;
}
table.mtdsimplecalendar th {
	background-color: #eeeeee;
	border: 1px dotted #000000;
	width: 2.2em;
	font-weight: normal;
}
table.mtdsimplecalendar td {
	border: 1px dotted #000000;
	text-align: center;
	padding: 3px;
}

th.mtdsimplecalendar-daynames {
	text-align: center;
	color: black;
}
td.mtdsimplecalendar-blank {
	background-color: lightgrey;
}
td.mtdsimplecalendar-today {
	background-color: #4B0082;
	color: #ffffff;
}
td.mtdsimplecalendar-day {
	background-color: #ffffff;
	color: slategrey;
}
");

SDV($mtdsimplecalendar_weekstart, 0); // Start on Sunday;
//SDV($mtdsimplecalendar_weekstart, 1); // Start on Monday;
SDV($mtdsimplecalendar_bottomsmalldatesep, '-'); // 2007-03-15
//SDV($mtdsimplecalendar_bottomsmalldatesep, '/'); // 2007/03/15

SDVA($mtdsimplecalendar_dayname,
	array("Sun", "Mon", "Tue", "Wed", "Thu", "Fri", "Sat")
//	array("Sunday", "Monday", "Tuesday", "Wednesday", "Thursday", "Friday", "Saturday")
);

Markup('mtdsimplecalendar','directives',"/^\(:mtdsimplecalendar:\)\s*$/e", "mtdsimplecalendar()");
function mtdsimplecalendar()
{ // {{{

	global $pagename;
	global $Group;
	// Config vars basically;
	global $mtdsimplecalendar_weekstart;
	global $mtdsimplecalendar_bottomsmalldatesep;
	global $mtdsimplecalendar_dayname;

	// Determine this Group
	$invocation_group = FmtPageName('$Group',$pagename);
	$name = FmtPageName('$Name',$pagename);

	// What is today?
	$tyear = date("Y");
	$tmonth = date("m");
	$tday = date("d");

//	// URL params else current.
//	$year = isset($_GET['year']) ? $_GET['year'] : $tyear;
//	$month = isset($_GET['month']) ? $_GET['month'] : $tmonth;
//	$day = isset($_GET['day']) ? $_GET['day'] : $tday;

	// Current date;.
	$year	= $tyear;
	$month	= $tmonth;
	$day	= $tday;


	$out = "";
	$out.= "<div id='mtdsimplecalendar'>";


	$itime	= mktime(0,0,0,$month,16,$year); // day 16, i.e. in the middle;
	$iyear	= strftime("%Y",$itime);
	$imonth	= strftime("%m",$itime);

	$monthname = strftime("%B %Y",$itime); // Full month name YYYY


	// 7 wide, as far down untill we run out.. (i.e. 5)
	$out.="<table class='mtdsimplecalendar'>";
	$out.="<caption>$monthname</caption>";


// From: <URL:http://us3.php.net/manual/en/function.mktime.php>
//$lastday = mktime(0, 0, 0, 3, 0, 2000);
//echo strftime("Last day in Feb 2000 is: %d", $lastday);
//$lastday = mktime(0, 0, 0, 4, -31, 2000);
//echo strftime("Last day in Feb 2000 is: %d", $lastday);
	$totaldays = date("t",mktime(0,0,0,$month,1,$year)); // from PmCal $totaldays
	$startdayofweek = date('w',mktime(0,0,0,$month,1,$year));	// from PmCal ($startdayofweek)

	// weekstart should be from 0 to 6. // also from PmCal
	$mtdsimplecalendar_weekstart=abs($mtdsimplecalendar_weekstart) % 7;
	if	(	$mtdsimplecalendar_weekstart >= 1
		&&	$startdayofweek == 0
		)
	{
		$startdayofweek = 7;
	}

	// Day names
	// $mtdsimplecalendar_weekstart=0 == (Sunday->Monday -> Friday->Saturday)
	// $mtdsimplecalendar_weekstart=1 == (Monday -> Friday->Saturday->Sunday)
	$out.="<tr>";
	for	(	$ind = 0; $ind < 7; $ind++)
	{

		$spacing = '';
		if	(	$ind == 0
			||	$ind == 6
			)
		{
			$spacing = ' width="15%"';
		}
		else
		{
			$spacing = ' width="14%"';
		}


		$d=($ind+$mtdsimplecalendar_weekstart) % 7;
		$out.="<th$spacing class='mtdsimplecalendar-daynames'><p>".$mtdsimplecalendar_dayname[$d]."</p></th>";
	}
	$out.="</tr>";


	$work = ($mtdsimplecalendar_weekstart-$startdayofweek);

	for	(	$index=($mtdsimplecalendar_weekstart-$startdayofweek); $index < $totaldays; )
	{
		$out.="<tr>";

		for	(	$ind = 0; $ind < 7; $ind++, $index++)
		{

			$daynum = $index+1;
			if ($index < 0)
			{ // empty cell before cal starts
				$out.="<td class='mtdsimplecalendar-blank'><p>&nbsp;</p></td>";
			}
			else if ($index >= $totaldays)
			{ // empty cell after cal ends.
				$out.="<td class='mtdsimplecalendar-blank'><p>&nbsp;</p></td>";
			}
			else
			{ // Normal cal cell.

				if	(	$daynum < 10)
				{
					$paddeddaynum = "0".$daynum;
				}
				else
				{
					$paddeddaynum = $daynum;
				}

				$daynumtext = $daynum;

				if	(	$tyear == $year
					&&	$tmonth == $month
					&&	$tday == $daynum
					)
				{	// TODAY
					$out.="<td class='mtdsimplecalendar-today'><p>$daynumtext</p></td>";
				}
				else
				{
					$out.="<td class='mtdsimplecalendar-day'><p>$daynumtext</p></td>";
				}

			}

		}

		$out.="</tr>";
	}

	$out.= "</table>";

	$out.= "<p>$year$mtdsimplecalendar_bottomsmalldatesep$month$mtdsimplecalendar_bottomsmalldatesep$day</p>";
//	$out.= "<p>".strftime("%#I:%M:%p on %A, %B %#d, %Y", time() )."</p>"; // 1:47:AM on Thursday, March 15, 2007
//	$out.= "<p>".strftime("%A, %Y/%m/%d @ %#I:%M:%p", time() )."</p>";
//	$out.= "<p>".strftime("%A, %Y/%m/%d", time() )."</p>";

	$out.= "</div>";

	return $out;
} // }}}


